.
. DB/C PAINT.PRG 
. (c) SUBJECT, WILLS AND COMPANY 1993
.
. This is a fully functional paint program that will demonstrate the various 
. GUI features in the DB/C language.
.
. NOTE: This program is GUI-based and must be run using DB/C for MS-Windows
. (DBCWIN.EXE), DB/C for OS/2 Presentation Manager (DBCPM.EXE) or DB/C for
. the Macintosh.
.
. tab setting should be 6:5

.
. Define a record to hold queue messages (window or resource)
rPrgMsg		record
c8Name		char 8	. name of window or resource
c4Func		char 4	. message function or type
c5Item		char 5	. menu or control item number (resource only)
c5Horz		char 5	. horizontal position
c5Vert		char 5	. vertical position
			recordend

.
. Define the main queue that will receive all window or resource queue messages
queMainQueue	queue entries=256, size=27

.
. Define the image variables used in this program
IMAGE_HSIZE	equate 600
IMAGE_VSIZE	equate 330
imgMainImage	image h=IMAGE_HSIZE, v=IMAGE_VSIZE, colorbits=24
imgColors		image h=160, v=20, colorbits=4
imgShapes		image h=400, v=400, colorbits=4
devTiffFile	device
devClipboard	device 

.
. Define the main window used in this program
devMainWin	device
WINDOW01		init "WINDOW01, TITLE=DB/C PAINT, SIZE=620:350, POS=1:100"
resMainPanel1	resource
MAINPANEL		init "PANEL=MAINPNL1,":		. name of panel resource
				"H=5, V=5, BOX=610:340"	. box control to surround image

.
. Define the secondary window used for color selection
devColorWin	device
COLORWIN		init "WINDOW02, TITLE=COLORS, SIZE=160:20, POS=10:10,":
				"NOCLOSE, FIXSIZE"

.
. Define the Main Menu resource string and resource variable
resMainMenu	resource
MAINMENU		init "MENU=MAINMENU,":					. name of menu resource (required)
					"MAIN=100:File,":				. first entry (from left to right) on menu bar
						"ITEM=101:New, KEY=^N,":		. first item under first menu bar entry
						"LINE,":					. separator
						"ITEM=102:Open, KEY=^O,":	. second item under first menu bar entry
						"ITEM=103:Save, KEY=^N,":	. third item under first menu bar entry
						"ITEM=104:Save as, KEY=^A,":	. fourth item under first menu bar entry
						"LINE,":					. separator
						"ITEM=105:Print, KEY=^P,":	. fifth item under first menu bar entry
						"ITEM=106:Print setup, KEY=^J,": . sixth item under first menu bar entry
						"LINE,":					. separator
						"ITEM=107:Exit, KEY=^X,":	. seventh item under first menu bar entry
					"MAIN=200:Line,":				. second entry on menu bar
						"ITEM=201:Draw line, KEY=F2,": . first item under second menu bar entry 	
						"LINE,":					. separator
						"SUBMENU=202:Width,":		. second item under second menu bar entry (a sub-menu)
							"ITEM=203:One pixel,":	. first item in width sub-menu 
							"ITEM=204:Two pixels,":	. second item in width sub-menu 
							"ITEM=205:Three pixels,": . third item in width sub-menu 
						"ENDSUBMENU,":				. end of width sub-menu
						"SUBMENU=206:Color,":		. third item under second menu bar entry (a sub-menu)
							"ITEM=207:Red,":		. first item in color sub-menu 
							"ITEM=208:Green,":		. second item in color sub-menu 
							"ITEM=209:Blue,":		. third item in color sub-menu
							"ITEM=210:Yellow,":		. fourth item in color sub-menu
							"ITEM=211:Cyan,":		. fifth item in color sub-menu
							"ITEM=212:Magenta,":	. sixth item in color sub-menu
							"ITEM=213:Black,":		. seventh item in color sub-menu
							"ITEM=214:White,":		. eighth item in color sub-menu
						"ENDSUBMENU,":				. end of color sub-menu
					"MAIN=300:Shape,":				. third entry on menu bar
						"ITEM=301:Draw circle, KEY=F2,":	. first item under third menu bar entry
						"ITEM=302:Draw rectangle, KEY=F3,": . second item under third menu bar entry
						"ITEM=303:Draw triangle, KEY=F4,":	. third item under third menu bar entry
					"MAIN=400:Text,":				. fourth entry on menu bar 
						"ITEM=401:Draw text, KEY=F5,": . first item under fourth menu bar entry
						"LINE,":					. separator
						"ITEM=402:Select font,":		. second item under fourth menu bar entry
					"MAIN=500:Messages,":			. fifth entry on menu bar
						"ITEM=501:Mouse messages on/off,":	. first item under fifth menu bar entry
					"MAIN=600:Clipboard,":			. sixth entry on menu bar
						"ITEM=601:Paste from,":		. first item under sixth menu bar entry
						"ITEM=602:Copy to"			. second item under sixth menu bar entry

.
. Define the Open dialog resource string and resource variable
resDialog1	resource
DIALOG1		init "DIALOG=DIALOG1, TITLE=Open, SIZE=260:185,":	. specify resource name and size of dialog box
				"H=73, V=10, TEXT=Enter filename,":			. static text
				"H=10, V=70, TEXT=The .TIF extension will be appended,": . static text
				"H=40, V=110, DEFPUSHBUTTON=101:OK:70:50,":		. default push button
	     		"H=140, V=110, ESCPUSHBUTTON=102:Cancel:70:50,":	. escape/cancel push button
				"H=70, V=37, EDIT=100:               :100"		. edit field to accept file name

.
. Define the Save as dialog resource string and resource variable
resDialog2	resource
DIALOG2		init "DIALOG=DIALOG2, TITLE=Save as, SIZE=260:185,":	. specify resource name and size of dialog box
				"H=73, V=10, TEXT=Enter filename,":			. static text
				"H=10, V=70, TEXT=The .TIF extension will be appended,": . static text
				"H=40, V=110, DEFPUSHBUTTON=101:OK:70:50,":		. default push button
	     		"H=140, V=110, ESCPUSHBUTTON=102:Cancel:70:50,":	. escape/cancel push button
				"H=70, V=37, EDIT=100:               :100"		. edit field to accept file name

.
. Define the window and the dialog resources used to size the shapes
devWindow3	device
WINDOW03		init "WINDOW03, TITLE=Circle, SIZE=400:400,":
				"POS=1:100, NOCLOSE, FIXSIZE"

resDialog3	resource
DIALOG3		init "DIALOG=DIALOG3, TITLE=Size Tool, SIZE=200:240,":
				"H=85, V=20, VSCROLLBAR=100:30:100,":			. vertical scroll bar
				"H=20, V=150, CHECKBOX=101:Filled circle,":		. check box
				"H=10, V=180, DEFPUSHBUTTON=102:OK:60:50,":		. default push button
	     		"H=130, V=180, ESCPUSHBUTTON=103:Cancel:60:50"	. escape/cancel push button

resDialog4	resource
DIALOG4		init "DIALOG=DIALOG4, TITLE=Size Tool, SIZE=200:280,":
				"H=85, V=20, VSCROLLBAR=100:30:100,":			. vertical scroll bar
				"H=20, V=150, HSCROLLBAR=101:160:30,": 			. horizontal scroll bar
				"H=20, V=190, CHECKBOX=102:Filled rectangle,":	. check box
				"H=10, V=220, DEFPUSHBUTTON=103:OK:60:50,":		. default push button
	     		"H=130, V=220, ESCPUSHBUTTON=104:Cancel:60:50"	. escape/cancel push button

resDialog5	resource
DIALOG5		init "DIALOG=DIALOG5, TITLE=Size Tool, SIZE=400:250,":
				"H=85, V=20, VSCROLLBAR=100:30:100,":			. vertical scroll bar
				"H=20, V=150, HSCROLLBAR=101:160:30,": 			. horizontal scroll bar
				"H=285, V=20, VSCROLLBAR=102:30:100,":			. vertical scroll bar
				"H=220, V=150, HSCROLLBAR=103:160:30,": 		. horizontal scroll bar
				"H=10, V=190, DEFPUSHBUTTON=104:OK:60:50,":		. default push button
	     		"H=230, V=190, ESCPUSHBUTTON=105:Cancel:60:50"	. escape/cancel push button

resDialog6	resource
DIALOG6		init "DIALOG=DIALOG6, TITLE=Draw text, SIZE=260:185,":	. specify resource name and size of dialog box
				"H=53, V=10, TEXT=Enter text to be drawn,":		. static text
				"H=40, V=110, DEFPUSHBUTTON=101:OK:70:50,":		. default push button
	     		"H=140, V=110, ESCPUSHBUTTON=102:Cancel:70:50,":	. escape/cancel push button
				"H=45, V=37, EDIT=100:                           :150"	. edit field to accept draw text

.
. Define the font dialog
resDialog7	resource
DIALOG7		init "DIALOG=DIALOG7, TITLE=Font Dialog, SIZE=300:195,":	. specify resource name and size of dialog box
				"H=10, V=20, DROPBOX=101:114:70,":
				"H=170, V=20, LISTBOX=102:104:70,":
				"H=14, V=125, CHECKBOX=103:Bold,":
				"H=115, V=125, CHECKBOX=104:Underline,":
				"H=230, V=125, CHECKBOX=105:Italic,":
				"H=14, V=160, DEFPUSHBUTTON=106:OK:66:29,":		. default push button
	     		"H=220, V=160, ESCPUSHBUTTON=107:Cancel:66:29"	. escape/cancel push button

.
. Define the Pen Width Dialog
resDialog8	resource
DIALOG8		init "DIALOG=DIALOG8, TITLE=Pen Dialog, SIZE=310:95,":
 				"H=7, V=2, BOXTITLE=Pen Width:298:45,":
				"BUTTONGROUP,":
				"H=18, V=18, BUTTON=101:One Pixel,":
				"H=103, V=18, BUTTON=102:Two Pixels,":
				"H=199, V=18, BUTTON=103:Three Pixels,":
				"ENDBUTTONGROUP,":
				"H=14, V=60, DEFPUSHBUTTON=104:OK:66:29,":		. default push button
	     		"H=230, V=60, ESCPUSHBUTTON=105:Cancel:66:29"	. escape/cancel push button

.
. Define various draw modes
i2DrawMode	int 2	. holds current draw mode 
MODE_LINE		equate 0
MODE_CIRCLE	equate 1
MODE_RECT		equate 2
MODE_TRIANGLE	equate 3
MODE_TEXT		equate 4

.
. Define Horizontal positions of colors in color window, their circular 
. radius and box width
HPOS_RED			equate 10	. horizontal position of the middle of color
HPOS_GREEN		equate 30
HPOS_BLUE			equate 50
HPOS_YELLOW		equate 70
HPOS_CYAN			equate 90
HPOS_MAGENTA		equate 110
HPOS_BLACK		equate 130
HPOS_WHITE		equate 150
HPOSSTART_RED		equate 1	. horizontal position of the start of the color
HPOSSTART_GREEN	equate 20
HPOSSTART_BLUE		equate 40
HPOSSTART_YELLOW	equate 60
HPOSSTART_CYAN		equate 80
HPOSSTART_MAGENTA	equate 100
HPOSSTART_BLACK	equate 120
HPOSSTART_WHITE	equate 140
HPOSEND_RED		equate 19	. horizontal position of the end of the color
HPOSEND_GREEN		equate 39
HPOSEND_BLUE		equate 59
HPOSEND_YELLOW		equate 79
HPOSEND_CYAN		equate 99
HPOSEND_MAGENTA	equate 119
HPOSEND_BLACK		equate 139
HPOSEND_WHITE		equate 159
COLOR_RADIUS		equate 8
COLOR_HALFWIDTH	equate 10
COLOR_WIDTH		equate 20

.
. other equates ...
IMAGE_HOFFSET	equate 10		. horizontal offset of image in main window
IMAGE_VOFFSET	equate 10		. vertical offset of image in main window
CIRCLE_RING	equate 0		. circle type, border only
CIRCLE_FILLED	equate 1		. circle type, filled
RECT_BORDER 	equate 0		. rectangle type, border only
RECT_FILLED 	equate 1		. rectangle type, filled
TRUE			equate 1
FALSE		equate 0

.
. define variables used in PAINT 
i1MouseOnFlag	int 1		. Flag set to TRUE to turn on mouse messages
i1ImgNamedFlag	int 1		. Flag set to TRUE if current image has been named
i1ImgSavedFlag int 1		. Flag set to TRUE when modified image is saved
c12FullName	init "UNTITLED.TIF"		. Current image name
c8CurName		init "UNTITLED"
c50Error		char 50		. holds any I/O error messages
resDialogErr	resource	. resource variable for error dialog, see ErrorBox
i15CurColor	int 15	. RGB value of current foreground color
i15BackColor	int 15	. RGB value of current background color
i3ForeClrH	int 3	. horz pos of the foreground color in the color window
i1CurPixWidth	int 1	. current pixel width for line drawing
i1CurCircleType int 1	. current circle type (filled or ring)
i4CurCircleRadius int 4  . current circle radius
i1CurRectType	int 1	. current rectangle type (filled or border)
i4CurRectWidth	int 4	. current rectangle width
i4CurRectHeight int 4	. current rectangle height
i4HorzOffset2	int 4	. current horz offset of triangle point 2
i4VertOffset2	int 4	. current vert offset of triangle point 2
i4HorzOffset3	int 4	. current horz offset of triangle point 3
i4VertOffset3	int 4	. current vert offset of triangle point 3
c50CurText	char 50	. current text for draw text mode
i5Item		int 5	. item number in integer form
i5Horz		int 5	. horizontal position in integer form
i5Vert		int 5	. vertical position in integer form

.
. define Font and Point size arrays, variables
MAXFONTS		equate 4
MAXPOINTSIZES	equate 6
ac10FontTxt	char 10[MAXFONTS], initial "COURIER   ", "HELVETICA ", "SYSTEM    ", "TIMES     "
ac13PointSizeTxt char 13[MAXPOINTSIZES], initial "Point size  8", "Point size 10", "Point size 12":
										"Point size 20", "Point size 30", "Point size 50"
ai2PointSize	int 2[MAXPOINTSIZES], initial 8, 10, 12, 20, 30, 50
DEFAULTFONT	equate	3 .	the default SYSTEM font
DEFAULTPOINTSIZE equate  2 .  the default point size

i2CurFontTxt	int 2	. current font name, ac10FontTxt[] array reference
i2CurPointSize	int 2	. current point size, ai2PointSize[] array reference
i1BoldFlg		int 1	. set to TRUE if bold attribute is currently on
i1ULineFlg	int 1	. set to TRUE if underline attribute is currently on
i1ItalicFlg	int 1	. set to TRUE if italic attribute is currently on
c60CurFont	char	60	. holds character variable describing current font for DRAW 

.
. Start of main program
.
PaintMain	
.
.	 set default Font attributes
	move DEFAULTFONT to i2CurFontTxt	
	move DEFAULTPOINTSIZE to i2CurPointSize 
	move FALSE to i1BoldFlg
	move FALSE to i1ULineFlg
	move FALSE to i1ItalicFlg
	call BuildCurrentFont
	
	trap TrapIOCatch giving c50Error noreset if io
	trap TrapPrintCatch giving c50Error noreset if spool
	move FALSE to i1MouseOnFlag
	move FALSE to i1ImgNamedFlag
	move TRUE to i1ImgSavedFlag
	move MODE_LINE to i2DrawMode
	move 1 to i1CurPixWidth
.
. 	Create main and color windows
 	call ShowColorWin
	call ShowMainWin
	call ShowMainMenu
.
. 	Start main message loop
MessageLoop
	loop
		wait queMainQueue
		get queMainQueue; rPrgMsg
		break if (rPrgMsg.c4Func = "CLOS")
.
.		if mouse messages are turned on, display in WINDOW00 
.		created by DISPLAY
		if (i1MouseOnFlag and (rPrgMsg.c4Func = "POSN" or :
			    rPrgMsg.c4Func = "LBDN" or :
			    rPrgMsg.c4Func = "LBUP" or :
			    rPrgMsg.c4Func = "LBDC" or :
			    rPrgMsg.c4Func = "MBDN" or :
			    rPrgMsg.c4Func = "MBUP" or :
			    rPrgMsg.c4Func = "MBDC" or :
			    rPrgMsg.c4Func = "RBDN" or :
			    rPrgMsg.c4Func = "RBUP" or :
			    rPrgMsg.c4Func = "RBDC"))
			display rPrgMsg
		endif
.
.		dispatch messages to appropriate handler		
		move rPrgMsg.c5Item to i5Item
		move rPrgMsg.c5Horz to i5Horz
		move rPrgMsg.c5Vert to i5Vert
		switch rPrgMsg.c8Name
			case "WINDOW01"
				call ProcessMainWin
			case "WINDOW02"
				call ProcessColorWin
			case "MAINMENU"
				call ProcessMainMenu
			case "DIALOG1 "
				call ProcessDialog1
			case "DIALOG2 "
				call ProcessDialog2
			case "DIALOG3 "
				call ProcessDialog3
			case "DIALOG4 "
				call ProcessDialog4
			case "DIALOG5 "
				call ProcessDialog5
			case "DIALOG6 "
				call ProcessDialog6
			case "DIALOG7 "
				call ProcessDialog7
			case "DIALOG8 "
				call ProcessDialog8
			case "DIALOGER"
				call ProcessDialogErr
		endswitch
	repeat
	stop


.
. ShowColorWin - This routine will display the secondary window that contains
. the various selectable colors within eight circles.
.
ShowColorWin lroutine
	draw imgColors; color=*black, erase:
	     color=*red, 	p=HPOS_RED:COLOR_HALFWIDTH,		bigdot=COLOR_RADIUS:
	     color=*green,	p=HPOS_GREEN:COLOR_HALFWIDTH,		bigdot=COLOR_RADIUS:
	     color=*blue,	p=HPOS_BLUE:COLOR_HALFWIDTH,		bigdot=COLOR_RADIUS:
	     color=*yellow,	p=HPOS_YELLOW:COLOR_HALFWIDTH,	bigdot=COLOR_RADIUS:
	     color=*cyan,	p=HPOS_CYAN:COLOR_HALFWIDTH,		bigdot=COLOR_RADIUS:
	     color=*magenta, p=HPOS_MAGENTA:COLOR_HALFWIDTH,	bigdot=COLOR_RADIUS:
	     color=*white,	p=HPOS_WHITE:COLOR_HALFWIDTH,		bigdot=COLOR_RADIUS
	prepare devColorWin, COLORWIN
	change devColorWin, "MOUSEON"
	show imgColors, devColorWin
	link devColorWin, queMainQueue
	move HPOS_BLACK to i3ForeClrH
	call SetColor with HPOS_BLACK, i3ForeClrH, i15CurColor
	return
	endroutine


.
. ShowMainWin - This routine will display the main paint window and the 
. image inside it.
.
ShowMainWin lroutine
	prepare devMainWin, WINDOW01
	prepare resMainPanel1, MAINPANEL
	draw imgMainImage; color=*white, erase, color=i15CurColor
	link devMainWin, queMainQueue
	show imgMainImage, devMainWin, 10, 10
	show resMainPanel1, devMainWin
	change devMainWin, "MOUSEON"
	return
	endroutine


.
. ShowMainMenu - This routine will prepare and display the main menu on the
. main paint window.
.
ShowMainMenu lroutine 
	prepare resMainMenu, MAINMENU
	link resMainMenu, queMainQueue
	show resMainMenu, devMainWin
	return
	endroutine


.
. SetColor - This routine will take a horizontal mouse position button click
. (or equate constant) in the address variable i@HPos and set the 
. corresponding foreground color from the color window.  
SetColor lroutine i@HPos, i@OldHPos, i@RGBColor
i@HPos		int @	. new foreground color horizontal pos within color window
i@OldHPos		int @	. old foreground color horizontal pos within color window
i@RGBColor	int @	. new foreground color RGB color value used by DRAW
.
.	unset old foreground color
	if (i@OldHPos <= HPOSEND_RED)
		draw imgColors; color=*black, p=HPOSSTART_RED:1:
			rectangle=HPOSEND_RED:COLOR_WIDTH:
	     	color=*red, p=HPOS_RED:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@OldHPos <= HPOSEND_GREEN)
		draw imgColors; color=*black, p=HPOSSTART_GREEN:1:
			rectangle=HPOSEND_GREEN:COLOR_WIDTH:
	     	color=*green, p=HPOS_GREEN:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@OldHPos <= HPOSEND_BLUE)
		draw imgColors; color=*black, p=HPOSSTART_BLUE:1:
			rectangle=HPOSEND_BLUE:COLOR_WIDTH:
	     	color=*blue, p=HPOS_BLUE:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@OldHPos <= HPOSEND_YELLOW)
		draw imgColors; color=*black, p=HPOSSTART_YELLOW:1:
			rectangle=HPOSEND_YELLOW:COLOR_WIDTH:
	     	color=*yellow, p=HPOS_YELLOW:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@OldHPos <= HPOSEND_CYAN)
		draw imgColors; color=*black, p=HPOSSTART_CYAN:1:
			rectangle=HPOSEND_CYAN:COLOR_WIDTH:
	     	color=*cyan, p=HPOS_CYAN:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@OldHPos <= HPOSEND_MAGENTA)
		draw imgColors; color=*black, p=HPOSSTART_MAGENTA:1:
			rectangle=HPOSEND_MAGENTA:COLOR_WIDTH:
	     	color=*magenta, p=HPOS_MAGENTA:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@OldHPos <= HPOSEND_BLACK)
		draw imgColors; color=*black, p=HPOSSTART_BLACK:1:
			rectangle=HPOSEND_BLACK:COLOR_WIDTH
	else 
		draw imgColors; color=*black, p=HPOSSTART_WHITE:1:
			rectangle=HPOSEND_WHITE:COLOR_WIDTH:
	     	color=*white, p=HPOS_WHITE:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	endif
.
.	set new foreground color
	if (i@HPos <= HPOSEND_RED)
		draw imgColors; color=*white, p=HPOSSTART_RED:1:
			rectangle=HPOSEND_RED:COLOR_WIDTH:
	     	color=*red, p=HPOS_RED:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@HPos <= HPOSEND_GREEN)
		draw imgColors; color=*white, p=HPOSSTART_GREEN:1:
			rectangle=HPOSEND_GREEN:COLOR_WIDTH:
	     	color=*green, p=HPOS_GREEN:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@HPos <= HPOSEND_BLUE)
		draw imgColors; color=*white, p=HPOSSTART_BLUE:1:
			rectangle=HPOSEND_BLUE:COLOR_WIDTH:
	     	color=*blue, p=HPOS_BLUE:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@HPos <= HPOSEND_YELLOW)
		draw imgColors; color=*white, p=HPOSSTART_YELLOW:1:
			rectangle=HPOSEND_YELLOW:COLOR_WIDTH:
	     	color=*yellow, p=HPOS_YELLOW:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@HPos <= HPOSEND_CYAN)
		draw imgColors; color=*white, p=HPOSSTART_CYAN:1:
			rectangle=HPOSEND_CYAN:COLOR_WIDTH:
	     	color=*cyan, p=HPOS_CYAN:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@HPos <= HPOSEND_MAGENTA)
		draw imgColors; color=*white, p=HPOSSTART_MAGENTA:1:
			rectangle=HPOSEND_MAGENTA:COLOR_WIDTH:
	     	color=*magenta, p=HPOS_MAGENTA:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else if (i@HPos <= HPOSEND_BLACK)
		draw imgColors; color=*white, p=HPOSSTART_BLACK:1:
			rectangle=HPOSEND_BLACK:COLOR_WIDTH:
	     	color=*black, p=HPOS_BLACK:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	else 
		draw imgColors; color=*cyan, p=HPOSSTART_WHITE:1:
			rectangle=HPOSEND_WHITE:COLOR_WIDTH:
	     	color=*white, p=HPOS_WHITE:COLOR_HALFWIDTH, bigdot=COLOR_RADIUS
	endif
	move i@HPos to i@OldHPos
	draw imgColors; p=i@HPos:COLOR_HALFWIDTH
	getcolor imgColors; i@RGBColor
	return
	endroutine

.
. ProcessMain - Process messages from the main window.
.
ProcessMainWin lroutine
i1LeftBtnFlag	int 1
	switch rPrgMsg.c4Func
		case "LBDN"	. left button down
			move TRUE to i1LeftBtnFlag
			move FALSE to i1ImgSavedFlag
			switch i2DrawMode
				case MODE_LINE
					draw imgMainImage; linewidth=i1CurPixWidth, color=i15CurColor:
						p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
						bigdot=i1CurPixWidth
				case MODE_CIRCLE  
					if (i1CurCircleType = CIRCLE_RING)
						draw imgMainImage; color=i15CurColor, linewidth=i1CurPixWidth:
							p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
							circle=i4CurCircleRadius
					else
						draw imgMainImage; color=i15CurColor:
							p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
							bigdot=i4CurCircleRadius
					endif
				case MODE_RECT
					if (i1CurRectType = RECT_BORDER)
						draw imgMainImage; color=i15CurColor, linewidth=i1CurPixWidth:
							p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
							box=(i5Horz - IMAGE_HOFFSET + i4CurRectWidth):(i5Vert - IMAGE_VOFFSET + i4CurRectHeight)
					else 
						draw imgMainImage; color=i15CurColor:
							p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
							rectangle=(i5Horz - IMAGE_HOFFSET + i4CurRectWidth):(i5Vert - IMAGE_VOFFSET + i4CurRectHeight)
					endif
				case MODE_TRIANGLE
					draw imgMainImage; color=i15CurColor:
						p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
						triangle=(i5Horz - IMAGE_HOFFSET + i4HorzOffset2):(i5Vert - IMAGE_VOFFSET + i4VertOffset2):(i5Horz - IMAGE_HOFFSET + i4HorzOffset3):(i5Vert - IMAGE_VOFFSET + i4VertOffset3)
				case MODE_TEXT
					draw imgMainImage; color=i15CurColor, font=c60CurFont:
						p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
						text=c50CurText
			endswitch
		case "POSN"	. position report (mouse moved)
			return if (not i1LeftBtnFlag)
			if (i5Horz <= IMAGE_HOFFSET) 
				move (IMAGE_HOFFSET + 1) to i5Horz
				clear i1LeftBtnFlag
			endif
			if (i5Vert <= IMAGE_VOFFSET) 
				move (IMAGE_VOFFSET + 1) to i5Vert
				clear i1LeftBtnFlag
			endif
			if (i5Horz > IMAGE_HOFFSET + IMAGE_HSIZE)
				move IMAGE_HSIZE to i5Horz
				clear i1LeftBtnFlag
			endif
			if (i5Vert > IMAGE_HOFFSET + IMAGE_VSIZE)
				move IMAGE_VSIZE to i5Vert
				clear i1LeftBtnFlag
			endif
			switch i2DrawMode
				case MODE_LINE
					draw imgMainImage; color=i15CurColor, line=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET)
				case MODE_CIRCLE
					if (i1CurCircleType = CIRCLE_RING)
						draw imgMainImage; color=i15CurColor:
							p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
							circle=i4CurCircleRadius
					else
						draw imgMainImage; color=i15CurColor:
							p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
							bigdot=i4CurCircleRadius
					endif
				case MODE_RECT
					if (i1CurRectType = RECT_BORDER)
						draw imgMainImage; color=i15CurColor:
							p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
							box=(i5Horz - IMAGE_HOFFSET + i4CurRectWidth):(i5Vert - IMAGE_VOFFSET + i4CurRectHeight)
					else 
						draw imgMainImage; color=i15CurColor:
							p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
							rectangle=(i5Horz - IMAGE_HOFFSET + i4CurRectWidth):(i5Vert - IMAGE_VOFFSET + i4CurRectHeight)
					endif
				case MODE_TRIANGLE
					draw imgMainImage; color=i15CurColor:
						p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
						triangle=(i5Horz - IMAGE_HOFFSET + i4HorzOffset2):(i5Vert - IMAGE_VOFFSET + i4VertOffset2):(i5Horz - IMAGE_HOFFSET + i4HorzOffset3):(i5Vert - IMAGE_VOFFSET + i4VertOffset3)
				case MODE_TEXT
					draw imgMainImage; color=i15CurColor, font=c60CurFont:
						p=(i5Horz - IMAGE_HOFFSET):(i5Vert - IMAGE_VOFFSET):
						text=c50CurText
			endswitch
		case "LBUP"	. left button up
			move FALSE to i1LeftBtnFlag
		case "RBUP"	. right button up, show pen dialog
			prepare resDialog8, DIALOG8
			link resDialog8, queMainQueue
			show resDialog8, devMainWin at (i5Horz - IMAGE_HOFFSET), (i5Vert - IMAGE_VOFFSET)
			switch i1CurPixWidth
				case 1
					change resDialog8, "MARK101"
 				case 2
					change resDialog8, "MARK102"
				case 3
					change resDialog8, "MARK103"
			endswitch
	endswitch
	return
	endroutine

.
. ProcessColorWin - Process messages from the color window.
.
ProcessColorWin lroutine
	switch rPrgMsg.c4Func
		case "LBDN"	. left button was pushed
			draw imgColors; p=i5Horz:i5Vert
			call SetColor with i5Horz, i3ForeClrH, i15CurColor
		case "RBDN"	. right button was pushed
			draw imgColors; p=i5Horz:i5Vert
			getcolor imgColors; i15BackColor
			draw imgMainImage; color=i15BackColor, erase
			move FALSE to i1ImgSavedFlag
	endswitch
	return
	endroutine

.
. ProcessMainMenu - Process messages from the main menu.
.
ProcessMainMenu lroutine
i2Ctr	int 2
	switch i5Item
		case 101		. New was selected
			draw imgMainImage; color=*white, erase, color=i15CurColor
		case 102		. Open existing tif file
			prepare resDialog1, DIALOG1
			link resDialog1, queMainQueue
			show resDialog1, devMainWin
			change resDialog1, "TEXT100"; c8CurName
			change resDialog1, "FOCUS100"
		case 103  	. Save current image to file (TIF format)
			return if (i1ImgSavedFlag = TRUE)
			if (i1ImgNamedFlag = FALSE)			. popup Save as dialog
				prepare resDialog2, DIALOG2
				link resDialog2, queMainQueue
				show resDialog2, devMainWin
				change resDialog2, "TEXT100"; c8CurName
				return
			endif
			prepare devTiffFile, c12FullName
			store imgMainImage to devTiffFile
			close devTiffFile
			move TRUE to i1ImgSavedFlag
		case 104		. Save as selected
			prepare resDialog2, DIALOG2
			link resDialog2, queMainQueue
			show resDialog2, devMainWin
			change resDialog2, "TEXT100"; c8CurName
			change resDialog1, "FOCUS100"
		case 105		. Print image was selected
			splopen "DEFAULT(300)", "J"
			print *p=1:1, imgMainImage, *n
			splclose
		case 106 		. Print setup was selected
			splopt "S"
		case 107		. Exit was selected
			move "WINDOW01" to rPrgMsg.c8Name
			move "CLOS" to rPrgMsg.c4Func
			putfirst queMainQueue; rPrgMsg
		case 201 		. set current draw mode to Line draw
			move MODE_LINE to i2DrawMode
		case 203		. Set line width to 1 pixel wide
			move 1 to i1CurPixWidth
		case 204		. Set line width to 2 pixels wide
			move 2 to i1CurPixWidth
		case 205		. Set line width to 3 pixels wide
			move 3 to i1CurPixWidth
		case 207		. set current fore color to Red
			call SetColor with HPOS_RED, i3ForeClrH, i15CurColor
		case 208		. set current fore color to Green
			call SetColor with HPOS_GREEN, i3ForeClrH, i15CurColor
		case 209		. set current fore color to Blue
			call SetColor with HPOS_BLUE, i3ForeClrH, i15CurColor
		case 210		. set current fore color to Yellow
			call SetColor with HPOS_YELLOW, i3ForeClrH, i15CurColor
		case 211		. set current fore color to Cyan
			call SetColor with HPOS_CYAN, i3ForeClrH, i15CurColor
		case 212		. set current fore color to Magenta
			call SetColor with HPOS_MAGENTA, i3ForeClrH, i15CurColor
		case 213		. set current fore color to Black
			call SetColor with HPOS_BLACK, i3ForeClrH, i15CurColor
		case 214		. set current fore color to White
			call SetColor with HPOS_WHITE, i3ForeClrH, i15CurColor
		case 301		. set current draw mode to Circle draw
			call SetCircleType
		case 302		. set current draw mode to Rectangle draw
			call SetRectType
		case 303		. set current draw mode to Triangle draw
			call SetTriangleType
		case 401		. set current draw mode to Text draw
			prepare resDialog6, DIALOG6
			link resDialog6, queMainQueue
			show resDialog6, devMainWin
			change resDialog6, "TEXT100"; c50CurText
			change resDialog6, "FOCUS100"
		case 402 		. show font dialog
			prepare resDialog7, DIALOG7
			link resDialog7, queMainQueue
			for i2Ctr from 1 to MAXFONTS
				change resDialog7, "INSERT101"; ac10FontTxt[i2Ctr] 
			repeat
			change resDialog7,"LOCATE101";ac10FontTxt[i2CurFontTxt]
			show resDialog7, devMainWin
			for i2Ctr from 1 to MAXPOINTSIZES		
				change resDialog7, "INSERT102"; ac13PointSizeTxt[i2Ctr]
			repeat
			change resDialog7, "LOCATE102"; ac13PointSizeTxt[i2CurPointSize]
			if (i1BoldFlg = TRUE)
				change resDialog7, "MARK103"
			endif
			if (i1ULineFlg = TRUE)
				change resDialog7, "MARK104"
			endif
			if (i1ItalicFlg = TRUE)
				change resDialog7, "MARK105"
			endif
		case 501 		. turn mouse messages on/off
			if (i1MouseOnFlag)
				move FALSE to i1MouseOnFlag
			else 
				move TRUE to i1MouseOnFlag
			endif
		case 601 		. retrieve image from clipboard
			open devClipboard, "CLIPBOARD"
			load imgMainImage from devClipboard
			close devClipboard
		case 602 		. update image in clipboard
			open devClipboard, "CLIPBOARD"
			store imgMainImage to devClipboard
			close devClipboard
	endswitch
	return
	endroutine

.
. ProcessDialog1 - Process messages from the Open dialog.
.
ProcessDialog1 lroutine
	switch i5Item
		case 101		. Default 'OK' push button was selected
			draw imgMainImage; color=*white, erase, color=i15CurColor
			query resDialog1, "STATUS100"; c8CurName
			move (squeeze (c8CurName + ".TIF")) to c12FullName
			open devTiffFile, c12FullName
			load imgMainImage from devTiffFile
			close devTiffFile
			if over
				call ErrorBox with "Invalid TIFF file"
			else 
				move TRUE to i1ImgSavedFlag
			endif
			unlink resDialog1
			close resDialog1
		case 102		. Esc push button was selected 
			unlink resDialog1
			close resDialog1
	endswitch
	return
	endroutine

.
. ProcessDialog2 - Process messages from the Save as dialog.
.
ProcessDialog2 lroutine
	switch i5Item
		case 101		. Default 'OK' push button was selected
			query resDialog2, "STATUS100"; c8CurName
			move (squeeze (c8CurName + ".TIF")) to c12FullName
			prepare devTiffFile, c12FullName
			store imgMainImage to devTiffFile
			close devTiffFile
			move TRUE to i1ImgSavedFlag
			unlink resDialog2
			close resDialog2
		case 102		. Esc push button was selected 
			unlink resDialog2
			close resDialog2
	endswitch
	return
	endroutine

.
. SetCircleType - Displays Circle dialog for prompting user for circle 
.			   dimensions.
.
SetCircleType lroutine 
	move 100 to i4CurCircleRadius
	move CIRCLE_RING to i1CurCircleType
	call UpdateCircleImage
	prepare devWindow3, WINDOW03
	link devWindow3, queMainQueue
	prepare resDialog3, DIALOG3
	link resDialog3, queMainQueue
	show resDialog3, devWindow3, 410, 100
	show imgShapes, devWindow3
	change resDialog3, "RANGE100"; "    1  200   15"
	change resDialog3, "POSITION100"; "  100"
	change resDialog3, "ITEMON"
	return
	endroutine

.
. UpdateCircleImage - Update image in Circle dialog with new dimensions 
.				  and/or filler.
.
UpdateCircleImage lroutine
	if (i1CurCircleType = CIRCLE_RING)
		draw imgShapes; color=*white, erase, color=i15CurColor:
			p=200:200, circle=i4CurCircleRadius
	else 
		draw imgShapes; color=*white, erase, color=i15CurColor:
			p=200:200, bigdot=i4CurCircleRadius
	endif
	return
	endroutine

.
. ProcessDialog3 - Process messages from the Circle dialog.
.
ProcessDialog3 lroutine
	switch i5Item
		case 100
			if (rPrgMsg.c4Func ! 2 = "SB")
				move i5Horz to i4CurCircleRadius
			endif
			call UpdateCircleImage
		case 101 
			if (rPrgMsg.c4Func = "ITEM")
				if (i1CurCircleType = CIRCLE_RING)
					move CIRCLE_FILLED to i1CurCircleType
				else 
					move CIRCLE_RING to i1CurCircleType
				endif
			endif
			call UpdateCircleImage
		case 102		. Default 'OK' push button was selected
			hide imgShapes
			unlink resDialog3
			close resDialog3
			unlink devWindow3
			close devWindow3
			move MODE_CIRCLE to i2DrawMode
		case 103		. Esc push button was selected 
			hide imgShapes
			unlink resDialog3
			close resDialog3
			unlink devWindow3
			close devWindow3
	endswitch
	return
	endroutine


.
. SetRectType - Displays rectangle dialog for prompting user for rectangle
.			 dimensions.
.
SetRectType lroutine 
	move 100 to i4CurRectWidth
	move 100 to i4CurRectHeight
	move RECT_BORDER to i1CurRectType
	call UpdateRectImage
	prepare devWindow3, WINDOW03
	change devWindow3, "TITLE"; "Rectangle"
	link devWindow3, queMainQueue
	prepare resDialog4, DIALOG4
	link resDialog4, queMainQueue
	show resDialog4, devWindow3, 410, 100
	show imgShapes, devWindow3
	change resDialog4, "RANGE100"; "    1  200   15"
	change resDialog4, "RANGE101"; "    1  200   15"
	change resDialog4, "POSITION100"; "  100"
	change resDialog4, "POSITION101"; "  100"
	change resDialog4, "ITEMON"
	return
	endroutine

.
. UpdateRectImage - Update image in Rectangle dialog with new dimensions 
.				and/or filler.
.
UpdateRectImage lroutine
i4HalfWidth	int 4
i4HalfHeight	int 4
	move (i4CurRectWidth / 2) to i4HalfWidth
	move (i4CurRectHeight / 2) to i4HalfHeight
	if (i1CurRectType = RECT_BORDER)
		draw imgShapes; color=*white, erase, color=i15CurColor:
			p=(200 - i4HalfWidth):(200 - i4HalfHeight):
			box=(200 + i4HalfWidth):(200 + i4HalfHeight)
	else 
		draw imgShapes; color=*white, erase, color=i15CurColor:
			p=(200 - i4HalfWidth):(200 - i4HalfHeight):
			rectangle=(200 + i4HalfWidth):(200 + i4HalfHeight)
	endif
	return
	endroutine

.
. ProcessDialog4 - Process messages from the Rectangle dialog.
.
ProcessDialog4 lroutine
	switch i5Item
		case 100
			if (rPrgMsg.c4Func ! 2 = "SB")
				move i5Horz to i4CurRectHeight
			endif
			call UpdateRectImage
		case 101
			if (rPrgMsg.c4Func ! 2 = "SB")
				move i5Horz to i4CurRectWidth
			endif
			call UpdateRectImage
		case 102 
			if (rPrgMsg.c4Func = "ITEM")
				if (i1CurRectType = RECT_BORDER)
					move RECT_FILLED to i1CurRectType
				else 
					move RECT_BORDER to i1CurRectType
				endif
			endif
			call UpdateRectImage
		case 103		. Default 'OK' push button was selected
			hide imgShapes
			unlink resDialog4
			close resDialog4
			unlink devWindow3
			close devWindow3
			move MODE_RECT to i2DrawMode
		case 104		. Esc push button was selected 
			hide imgShapes
			unlink resDialog4
			close resDialog4
			unlink devWindow3
			close devWindow3
	endswitch
	return
	endroutine


.
. SetTriangleType - Displays triangle dialog for prompting user for triangle
.			 	dimensions.
.
SetTriangleType lroutine 
	move 100 to i4VertOffset2, i4VertOffset3
	move -50 to i4HorzOffset2
	move 50 to i4HorzOffset3
	call UpdateTriangleImage
	prepare devWindow3, WINDOW03
	change devWindow3, "TITLE"; "Triangle"
	link devWindow3, queMainQueue
	prepare resDialog5, DIALOG5
	link resDialog5, queMainQueue
	show resDialog5, devWindow3, 410, 100
	show imgShapes, devWindow3
	change resDialog5, "RANGE100"; "    1  400   15"
	change resDialog5, "RANGE101"; "    1  400   15"
	change resDialog5, "RANGE102"; "    1  400   15"
	change resDialog5, "RANGE103"; "    1  400   15"
	change resDialog5, "POSITION100"; "  300"
	change resDialog5, "POSITION101"; "  150"
	change resDialog5, "POSITION102"; "  300"
	change resDialog5, "POSITION103"; "  250"
	change resDialog5, "ITEMON"
	return
	endroutine

.
. UpdateTriangleImage - Update image in Triangle window with new dimensions.
.
UpdateTriangleImage lroutine
	draw imgShapes; color=*white, erase, color=i15CurColor, p=200:200:
		triangle=(200 + i4HorzOffset2):(200 + i4VertOffset2):(200 + i4HorzOffset3):(200 + i4VertOffset3)
	return
	endroutine

.
. ProcessDialog5 - Process messages from the Triangle dialog.
.
ProcessDialog5 lroutine
	switch i5Item
		case 100
			if (rPrgMsg.c4Func ! 2 = "SB")
				move (i5Horz - 200) to i4VertOffset2
			endif
			call UpdateTriangleImage
		case 101
			if (rPrgMsg.c4Func ! 2 = "SB")
				move (i5Horz - 200) to i4HorzOffset2
			endif
			call UpdateTriangleImage
		case 102
			if (rPrgMsg.c4Func ! 2 = "SB")
				move (i5Horz - 200) to i4VertOffset3
			endif
			call UpdateTriangleImage
		case 103
			if (rPrgMsg.c4Func ! 2 = "SB")
				move (i5Horz - 200) to i4HorzOffset3
			endif
			call UpdateTriangleImage
		case 104		. Default 'OK' push button was selected
			hide imgShapes
			unlink resDialog5
			close resDialog5
			unlink devWindow3
			close devWindow3
			move MODE_TRIANGLE to i2DrawMode
		case 105		. Esc push button was selected 
			hide imgShapes
			unlink resDialog5
			close resDialog5
			unlink devWindow3
			close devWindow3
	endswitch
	return
	endroutine

.
. ProcessDialog6 - Process messages from the draw Text dialog.
.
ProcessDialog6 lroutine
	switch i5Item
		case 101		. Default 'OK' push button was selected
			query resDialog6, "STATUS100"; c50CurText
			unlink resDialog6
			close resDialog6
			move MODE_TEXT to i2DrawMode
		case 102		. Esc push button was selected 
			unlink resDialog6
			close resDialog6
	endswitch
	return
	endroutine

.
. ProcessDialog7 - Process messages from the font dialog.
.
ProcessDialog7 lroutine
c1Status	char 1
c10DBoxSelection	char 10	. selection from drop box (font)
c13LBoxSelection	char 13	. selection from list box (point size)
	switch i5Item
		case 106		. Default 'OK' push button was selected
			query resDialog7, "STATUS103"; c1Status
			if (c1Status = "Y")
				move TRUE to i1BoldFlg
			else 
				move FALSE to i1BoldFlg
			endif
			query resDialog7, "STATUS104"; c1Status
			if (c1Status = "Y")
				move TRUE to i1ULineFlg
			else 
				move FALSE to i1ULineFlg
			endif
			query resDialog7, "STATUS105"; c1Status
			if (c1Status = "Y")
				move TRUE to i1ItalicFlg
			else 
				move FALSE to i1ItalicFlg
			endif
			query resDialog7, "STATUS101"; c10DBoxSelection
			query resDialog7, "STATUS102"; c13LBoxSelection
			unlink resDialog7
			close resDialog7
			debug
			search c10DBoxSelection in ac10FontTxt[1] to MAXFONTS with i2CurFontTxt
			search c13LBoxSelection in ac13PointSizeTxt[1] to MAXPOINTSIZES with i2CurPointSize
			call BuildCurrentFont
		case 107		. Esc push button was selected 
			unlink resDialog7
			close resDialog7
	endswitch
	return
	endroutine

.
. ProcessDialog8 - Process messages from the pen style dialog.
.
ProcessDialog8 lroutine
c1Status	char 1
	switch i5Item
		case 104		. Default 'OK' push button was selected
			query resDialog8, "STATUS101"; c1Status
			if (c1Status = "Y")
				move 1 to i1CurPixWidth
			else 
				query resDialog8, "STATUS102"; c1Status
				if (c1Status = "Y")
					move 2 to i1CurPixWidth
				else 
					move 3 to i1CurPixWidth
				endif
			endif
			unlink resDialog8
			close resDialog8
		case 105		. Esc push button was selected 
			unlink resDialog8
			close resDialog8
	endswitch
	return
	endroutine

.
. ProcessDialogErr - Process messages from the ErrorBox error dialog.
.
ProcessDialogErr lroutine 
	if (i5Item = 100)
		unlink resDialogErr
		close resDialogErr
	endif
	return
	endroutine

.
. ErrorBox - Displays a standard error message dialog.
.
ErrorBox lroutine c@Message
c@Message		char @		. Error message
DIALOGERRa	init "DIALOG=DIALOGER, TITLE=DB/C Paint Error, SIZE=320:155,":
				"H=63, V=30, TEXT=" 
DIALOGERRb 	init ", H=120, V=90, DEFPUSHBUTTON=100:OK:80:50"
		prepare resDialogErr, (DIALOGERRa + chop c@Message + DIALOGERRb)
		link resDialogErr, queMainQueue
		show resDialogErr, devMainWin
		return
		endroutine

.
. TrapIOCatch lroutine - This is the error handler for any I/O errors.
.
TrapIOCatch lroutine
i5StackSize	int 5
		call ErrorBox with c50Error
		retcount i5StackSize		. unwind the call stack
		loop while (i5StackSize > 0)
			noreturn
			subtract 1 from i5StackSize
		repeat
		goto MessageLoop
		endroutine

.
. TrapPrintCatch lroutine - This is the error handler for any spool errors.
.
TrapPrintCatch lroutine
i5StackSize	int 5
		call ErrorBox with "<<<< Print Canceled. >>>>"
		retcount i5StackSize		. unwind the call stack
		loop while (i5StackSize > 0)
			noreturn
			subtract 1 from i5StackSize
		repeat
		goto MessageLoop
		endroutine

.
. BuildCurrentFont lroutine - This routine will take the current font name
.						and attributes and build the text needed for
.						setting the font with the DRAW verb.
.
BuildCurrentFont lroutine
	move (chop ac10FontTxt[i2CurFontTxt]) to c60CurFont
	endset c60CurFont
	append "(" to c60CurFont
	if (i1BoldFlg = TRUE)
		append "BOLD" to c60CurFont
	else 
		append "NOBOLD" to c60CurFont
	endif
	if (i1ULineFlg = TRUE)
		append ", UNDERLINE" to c60CurFont
	else 
		append ", NOUNDERLINE" to c60CurFont
	endif
	if (i1ItalicFlg = TRUE)
		append ", ITALIC, " to c60CurFont
	else 
		append ", NOITALIC, " to c60CurFont
	endif
	append ai2PointSize[i2CurPointSize] to c60CurFont
	append ")" to c60CurFont
	reset c60CurFont
	return
	endroutine

